#include "StdAfx.h"
#include "2DWindowHandler.h"
#include "../TutorialApp.h"

bool TwoDWindowHandler::Initialize(CDialog& parent_dlg, int control_id)
{
  if( !m_window.ReplaceDialogControl(parent_dlg.m_hWnd, control_id) )
    return false;

  if( !m_window.AttachHandler(this) )
    return false;

  float t = theApp.Get2D().GetTop();
  float l = theApp.Get2D().GetLeft();

  vec3 center(0.0f,0.0f,0.0f);
  float ySize=t*2.0f, zSize=0.0f;
  float xSize = ySize * this->GetAspectRatio();
  SetWCWindow(UWB_BoundingBox(center, xSize, ySize, zSize));
  
  return true;
}

void TwoDWindowHandler::DrawGraphics()
{
  if(NULL == m_pD3DDevice)
    return;

  BeginDraw();

  // Set the model matrix to identity
  D3DXMATRIX identity;
  D3DXMatrixIdentity(&identity);
  m_pD3DDevice->SetTransform( D3DTS_WORLD, &identity);
  m_pD3DDevice->SetTransform( D3DTS_VIEW, &identity);
  m_pD3DDevice->SetTransform( D3DTS_PROJECTION, &identity);
  LoadW2NDCXform();

  //clear the draw buffer to light gray
  D3DCOLOR background = D3DCOLOR_COLORVALUE(0.2f, 0.5f, 0.2f, 0);
  m_pD3DDevice->Clear(0,                // number of rectangles, 0 means the entire area
                      NULL,             // rectangles to be cleared, NULL means the entire area
                      D3DCLEAR_TARGET|  // clear target (color) 
                      D3DCLEAR_ZBUFFER, // and clear z-buffer
                      background,// new color to clear to
                      1.0f,             // new Z values to clear to
                      0);               // new Stencil buffer values to clear to

  //perform all of our drawing
  theApp.Get2D().Draw2D();

  EndDrawAndShow();
}