#include "StdAfx.h"
#include "2DWorld.h"

TwoDWorld::TwoDWorld()
: m_pTeapotNode(NULL)
, m_pShusuiNode(NULL)
, m_pTigerNode(NULL)
, m_Selected(NULL)
{}

TwoDWorld::~TwoDWorld()
{}

void TwoDWorld::DrawNode(UWBD3D_DrawHelper &dh, UWB_SceneNode *n)
{
  UWB_XformInfo txf = n->GetXformInfo();
  vec3 p = txf.GetTranslation();
  UWB_XformInfo xf;
  xf.SetScale(1.0f);
  vec3 p2d(p.x, p.z, 0.0f);
  xf.SetTranslation(p2d);
  dh.PushModelTransform();
      xf.SetUpModelStack(dh);
      n->GetPrimitive()->Draw(dh.GetLOD(), dh);
  dh.PopModelTransform();
}

void TwoDWorld::Draw2D()
{
  UWBD3D_DrawHelper dh;

  
  if (NULL != m_pTeapotNode)
    DrawNode(dh, m_pTeapotNode);

  if (NULL != m_pShusuiNode)
    DrawNode(dh, m_pShusuiNode);

  if (NULL != m_pTigerNode)
    DrawNode(dh, m_pTigerNode);

  UWB_PrimitivePoint pt;
  pt.SetShadeMode(smFlat);
  pt.EnableLighting(false);
  pt.SetFlatColor(UWB_Color(1.0f, 1.0f, 1.0f));
  pt.SetPointSize(10.0f);
  float w = GetLeft();
  float h = GetTop();
  float delta = w * 0.05f;
  pt.SetLocation(-w+delta, -h+delta, 0);
  pt.Draw(dh.GetLOD(), dh);

  pt.SetLocation(-w+delta, h-delta, 0);
  pt.Draw(dh.GetLOD(), dh);

  pt.SetLocation(w-delta, h-delta, 0);
  pt.Draw(dh.GetLOD(), dh);

  pt.SetLocation(w-delta, -h+delta, 0);
  pt.Draw(dh.GetLOD(), dh);

  UWB_PrimitiveLine ln;
  ln.SetShadeMode(smFlat);
  ln.EnableLighting(false);
  ln.SetFlatColor(UWB_Color(1.0f, 0.0f, 0.0f, 0.0f));
  ln.SetStartPoint(0.0f, 0.0f, 0.0f);
  ln.SetEndPoint(3.0f, 0.0f, 0.0f);
  ln.Draw(dh.GetLOD(), dh);

  ln.SetFlatColor(UWB_Color(0.0f, 0.0f, 1.0f, 0.0f));
  ln.SetEndPoint(0.0f, 3.0f, 0.0f);
  ln.Draw(dh.GetLOD(), dh);
}