#include "StdAfx.h"
#include "2DWorld.h"

#define TOLERANCE 0.3f

float TwoDWorld::DistanceToNode(vec3 pt, UWB_SceneNode *n)
{
   UWB_XformInfo xf = n->GetXformInfo();
   vec3 tp = xf.GetTranslation();
   vec3 t2d(tp.x, tp.z, 0.0f);
   return length(t2d-pt);
}

void TwoDWorld::SelectPosition(float x, float y)
{
  vec3 pt(x, y, 0.0f);

  m_Selected = NULL;

  if (NULL != m_pTeapotNode) {
    float d = DistanceToNode(pt, m_pTeapotNode);
    if ( d < TOLERANCE )
      m_Selected = m_pTeapotNode;
  }

  if (NULL != m_pShusuiNode) {
    float d = DistanceToNode(pt, m_pShusuiNode);
    if (d < TOLERANCE)
      m_Selected = m_pShusuiNode;
  }
}

void TwoDWorld::MoveSelectionTo(float x, float y)
{
  if (NULL != m_Selected) {
    UWB_XformInfo xf = m_Selected->GetXformInfo();
    vec3 p = xf.GetTranslation();
    xf.SetTranslation(vec3(x, p.y, y));
    m_Selected->SetXformInfo(xf);
  }
}