#pragma once

enum LightColorSliderControls {
		eLightColorSliderControlsDiffuse = 0,
		eLightColorSliderControlsSpecular = 1,
		eLightColorSliderControlsAmbient = 2
};

enum LightPosSliderControls {
		eLightPosSliderControlsPosition = 0,
		eLightPosSliderControlsDirection = 1,
};

// LightControl dialog

class LightControl : public CDialog
{
	DECLARE_DYNAMIC(LightControl)

public:
	LightControl(CWnd* pParent = NULL);   // standard constructor
	virtual ~LightControl();

// Dialog Data
	enum { IDD = IDD_LIGHT_CONTROL };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog(); 

	DECLARE_MESSAGE_MAP()

	void LightSetsControl();
  void ControlSetsLight(const UWB_Color &, const vec3&);
	UWBD3D_Light										 *m_Light;
	LightColorSliderControls 	m_LgtColorControls;
	LightPosSliderControls 		m_LgtPosControls;
	
public:
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnBnClickedLgtPoint();
  afx_msg void OnBnClickedLgtDirectional();
  afx_msg void OnBnClickedLgtSpot();
  afx_msg void OnBnClickedLgtPosition();
  afx_msg void OnBnClickedLgtDirection();
  afx_msg void OnBnClickedLgtDiffuse();
  afx_msg void OnBnClickedLgtSpecular();
  afx_msg void OnBnClickedLgtAmbient();
  afx_msg void OnBnClickedLgtSwitch();
  afx_msg void OnBnClickedLgtDraw();

	UWBMFC_SliderCtrlWithEcho	m_XSlider;		// for Pos and Dir
	UWBMFC_SliderCtrlWithEcho	m_YSlider;		// for Pos and Dir
	UWBMFC_SliderCtrlWithEcho	m_ZSlider;		// for Pos and Dir

	UWBMFC_SliderCtrlWithEcho	m_RSlider;
	UWBMFC_SliderCtrlWithEcho	m_GSlider;
	UWBMFC_SliderCtrlWithEcho	m_BSlider;
	UWBMFC_SliderCtrlWithEcho	m_ASlider;

	UWBMFC_SliderCtrlWithEcho m_ThetaSlider;
	UWBMFC_SliderCtrlWithEcho m_PhiSlider;
	UWBMFC_SliderCtrlWithEcho m_FallOffSlider;
  BOOL m_LightIsOn;
  BOOL m_ShouldDrawLight;
};
