#include "StdAfx.h"
#include "Model.h"

void CModel::ComputeFollowCam()
{
    if (NULL == m_FollowCam)
      return;

    UWB_XformInfo txf = m_pTigerNode->GetXformInfo();
    vec3 p = txf.GetTranslation();
    mat3 tigerM = txf.GetRotation();
    vec3 tigerFront(0,0,-1), tigerUp(0, 1, 0);

    vec3 currentFront = tigerFront * tigerM;
    vec3 currentUp = tigerUp * tigerM;

    // position of camera is slightly infront/above the tiger ...
    vec3 cameraPos = p - (2.5f * currentFront ) + (1.5f * currentUp);
    vec3 at = p + 8.0f * currentFront;
    m_FollowCam->SetCameraPosition(cameraPos);
    m_FollowCam->SetCameraLookAt(at);
    m_FollowCam->SetCameraUpVector(currentUp);
    m_FollowCam->ResetRotation();
}