#include "StdAfx.h"
#include "Model.h"

void CModel::ComputeTigerCam()
{
    if (NULL == m_TigerCam)
      return;

    UWB_XformInfo txf = m_pTigerNode->GetXformInfo();
    vec3 p = txf.GetTranslation();
    mat3 tigerM = txf.GetRotation();
    vec3 tigerFront(0,0,-1), tigerUp(0, 1, 0);

    vec3 currentFront = tigerFront * tigerM;
    vec3 currentUp = tigerUp * tigerM;

    // position of camera is slightly infront/above the tiger ...
    vec3 cameraPos = p + (1.5f * currentFront ) + (0.5f * currentUp);
    vec3 at = cameraPos + 15.f * currentFront;
    m_TigerCam->SetCameraPosition(cameraPos);
    m_TigerCam->SetCameraLookAt(at);
    m_TigerCam->SetCameraUpVector(currentUp);
    m_TigerCam->ResetRotation();
}