// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DResource1.h"

/// A texture resource class contains the information about a texture that
/// has been loaded into a graphics API specific implementation.
class UWBD3D_TextureResource : public UWBD3D_Resource {
public:
  UWBD3D_TextureResource();
  ~UWBD3D_TextureResource();

  ///
  /// Get the Direct3D texture for this image
  LPDIRECT3DTEXTURE9 GetD3DTexture() { return m_pTexture; }
protected:
  virtual void ReleaseMemory(); 
  virtual bool LoadResourceFromFile(const wchar_t* fullPathName);
  
  LPDIRECT3DTEXTURE9 m_pTexture;
};
