#include "uwbgl_PrimitivePoint6.h"

UWB_PrimitivePoint::UWB_PrimitivePoint()
: m_point(0,0,0)
{
  m_bounds.SetCorners( m_point , m_point );
}

UWB_PrimitivePoint::UWB_PrimitivePoint(float x, float y, float z)
: m_point(x,y,z)
{
  m_bounds.SetCorners( m_point , m_point );
}

void UWB_PrimitivePoint::MouseDownVertex(int vertexID, float x, float y)
{
  SetLocation(x,y);
}

void UWB_PrimitivePoint::MoveTo(float x, float y)
{
  SetLocation(x,y);
}

void UWB_PrimitivePoint::SetupDrawAttributes(UWB_DrawHelper& draw_helper)
{
  __super::SetupDrawAttributes(draw_helper);
  draw_helper.SetPointSize(m_PointSize);
}

void UWB_PrimitivePoint::DrawPrimitive(eLevelOfDetail lod, UWB_DrawHelper& draw_helper)
{
  draw_helper.DrawPoint(m_point);
}


void UWB_PrimitivePoint::SetLocation(float x, float y, float z)
{
  m_point = vec3(x,y,z);
  m_bounds.SetCorners( m_point , m_point );
}

vec3 UWB_PrimitivePoint::GetLocation() const
{
  return m_point;
}

void UWB_PrimitivePoint::Update(float elapsed_seconds)
{
  // current position is defined by previous position + velocity * time
  vec3 adjust_vec = m_velocity * elapsed_seconds;
  m_point += adjust_vec;
  m_bounds.SetCorners( m_point , m_point );
}

const UWB_BoundingVolume* UWB_PrimitivePoint::GetBoundingVolume(eLevelOfDetail lod) const
{
  return &m_bounds;
}
